#include <iostream>
#include <fstream>
#include <cstring>
using namespace std;

const int MAXS = 100;
const int MAXV = 100;
const int MAXP = 100;

struct Data {
	int giorno;
	int mese;
	int anno;
};

struct Visita {
	Data data;
	float peso;
	int pressMin;
	int pressMax;
};

struct Paziente {
	char nome[MAXS];
	char cognome[MAXS];
	Visita vis[MAXV];
	int numVis;		
};

struct Archivio {
	Paziente paz[MAXP];
	int numPaz;
};

Paziente maggioreVariazionePeso(const Archivio* pa); 
void stampaInAumento(const Archivio* pa, int k);
int selezPressione(const Archivio* pa, int pmin, int pmax, Paziente vett[]);
bool inserisci(Archivio* pa, const char n[], const char c[], Visita v);
bool salva(const Archivio* pa, const char nome[], const char cognome[]);

Data leggiData(){
	Data d;
	cout << "Inserisci giorno: ";
	cin >>d.giorno;
	cout << "Inserisci mese: ";
	cin >>d.mese;
	cout << "Inserisci anno: ";
	cin >>d.anno;
	return d;
}

Visita leggiVisita() {
	Visita v;
	v.data = leggiData();
	cout << "Inserisci peso: ";
	cin >>v.peso;
	cout << "Inserisci press min: ";
	cin >>v.pressMin;
	cout << "Inserisci press max: ";
	cin >>v.pressMax;
	return v;
}

void stampaData(Data d) {
	cout << d.giorno << '/' << d.mese << '/' << d.anno;
}

void stampa(Paziente p) {
	cout << p.nome << ' ' << p.cognome << endl;
	for(int i=0; i<p.numVis; i++) {
		stampaData(p.vis[i].data);
		cout << '\t' << p.vis[i].peso << ' ' << p.vis[i].pressMin << ' ' << p.vis[i].pressMax << endl;
	}	
}

void stampa(const Archivio* pa) {
	for(int i=0; i<pa->numPaz; i++) {
		stampa(pa->paz[i]);
		cout << "------------------------\n";
	}
}

void menu(){
  cout << "\n\n###########MENU#############" << endl;
	cout << "1) maggiore variazione peso" << endl;
	cout << "2) stampa in aumento" << endl;
	cout << "3) seleziona pressione" << endl;
	cout << "4) inserisci visita" << endl;
	cout << "5) salva" << endl;
	cout << "6) stampa tutto" << endl;
	cout << "7) esci" << endl;
  cout << "? ";
}

void carica(Archivio* pa) {
	fstream ff;
	ff.open("input.txt", ios::in);
  int x, y;
  ff >> x;
  for(int i=0; i<x; i++) {
    Paziente p;
    Data d;
    ff >> p.nome;
    ff >> p.cognome;
    ff >> y;
    for(int j=0; j<y; j++) {
      Visita v;
      ff >> d.giorno >> d.mese >> d.anno;
      v.data = d;
      ff >> v.peso >> v.pressMin >> v.pressMax; 
      p.vis[j] = v;
    }
    p.numVis = y;
    pa->paz[i] = p;
  }
  pa->numPaz = x;
}

int main(){
	Archivio arc;
	arc.numPaz = 0;
	carica(&arc);
	
	char s;
	Visita vi;
	Paziente p;
	int k, q;
	Paziente v[MAXP];
	int pmax, pmin;
	bool ris;
	char n[MAXS], c[MAXS];
	while(true) {
		menu();
		cin >> s;
		switch(s) {
			case '1':
				p = maggioreVariazionePeso(&arc);
				cout << "Il paziente che ha avuto la maggiore variazione di peso e':"<< endl;
				cout << p.nome << ' ' << p.cognome << endl;
				break;
			case '2':
				cout << "Inserisci k: ";
				cin >> k;
				stampaInAumento(&arc, k);
				break;
			case '3':
				cout << "Inserisci pmin: ";
				cin >> pmin;
				cout << "Inserisci pmax: ";
				cin >>pmax;
				q = selezPressione(&arc, pmin, pmax, v);
				cout << "I pazienti selezionati sono:" << endl;
				for(int i=0; i<q; i++) 
					stampa(v[i]);
				break;
			case '4':
				cout << "Inserisci nome: ";
				cin >> n;
				cout << "Inserisci cognome: ";
				cin >> c;
				vi = leggiVisita();
				ris = inserisci(&arc, n, c, vi);
				break;
			case '5':
				cout << "Inserisci nome: ";
				cin >> n;
				cout << "Inserisci cognome: ";
				cin >> c;
				ris = salva(&arc, n, c);
				if(!ris) {
					cout << "Problema durante il salvataggio" << endl;	
				}
				break;
			case '6':
				stampa(&arc);
				break;
			case '7':
				return 0;
		}
	}
}
