#include <iostream>
#include <fstream>
#include <cstring>
using namespace std;

const int MAXS = 100;
const int MAXV = 100;
const int MAXP = 100;

struct Data {
	int giorno;
	int mese;
	int anno;
};

struct Visita {
	Data data;
	float peso;
	int pressMin;
	int pressMax;
};

struct Paziente {
	char nome[MAXS];
	char cognome[MAXS];
	Visita vis[MAXV];
	int numVis;		
};

struct Archivio {
	Paziente paz[MAXP];
	int numPaz;
};

float variazionePeso(const Paziente* pp) {
	float vp;
	vp = pp->vis[0].peso - pp->vis[pp->numVis-1].peso;
	vp = vp < 0 ? -vp : vp;
	return vp;
}

Paziente maggioreVariazionePeso(const Archivio* pa) {
	float vp;
	float maxvp = 0;
	int index;
	for(int i=0; i<pa->numPaz; i++) {
		vp = variazionePeso(&pa->paz[i]);
		if(vp > maxvp) {
			index = i;
			maxvp = vp;
		}	
	}
	return pa->paz[index];
}

bool inAumento(const Paziente* pp, int k) {
	bool cresc;
	for(int i=0; i<pp->numVis-k; i++) {
		cresc = true;
		for(int j=0; j<k; j++) {
			if(pp->vis[i+j].peso >= pp->vis[i+j+1].peso)
				cresc = false;
		}
		if(cresc) return true;
	}
	return false;
}

void stampaInAumento(const Archivio* pa, int k) {
	for(int i=0; i<pa->numPaz; i++)
		if(inAumento(&pa->paz[i], k))
			cout << pa->paz[i].nome << ' ' << pa->paz[i].cognome << endl;
} 

bool controllaPressione(const Paziente* pp, int pmin, int pmax) {
	for(int j=0; j<pp->numVis; j++)
		if(pp->vis[j].pressMin < pmin || pp->vis[j].pressMax > pmax) 
			return true;
	return false;
}

int selezPressione(const Archivio* pa, int pmin, int pmax, Paziente vett[]) {
	int conta = 0;
	for(int i=0; i<pa->numPaz; i++) {
		if(controllaPressione(&pa->paz[i], pmin, pmax))
			vett[conta++] = pa->paz[i]; 
	}
	return conta;
}

int confronta(Data a, Data b) {
	if(a.anno != b.anno) return a.anno - b.anno;
	if(a.mese != b.mese) return a.mese - b.mese;
	return a.giorno - b.giorno;
}

bool inserisci(Paziente* pp, Visita v) {
	if(pp->numVis == MAXV) 
		return false;
	int i;
	for(i=0; i<pp->numVis && confronta(pp->vis[i].data, v.data) < 0; i++);
	for(int j=pp->numVis; j>i; j--)
		pp->vis[j] = pp->vis[j-1];
	pp->vis[i] = v;
	pp->numVis++;
	return true;
}

bool inserisci(Archivio* pa, const char n[], const char c[], Visita v) {
	for(int i=0; i<pa->numPaz; i++)
		if(strcmp(pa->paz[i].nome, n) == 0 && strcmp(pa->paz[i].cognome, c) == 0)
			return inserisci(&pa->paz[i], v);
	return false;
}

bool salva(const Archivio* pa, const char nome[], const char cognome[]) {
	fstream f1, f2;
	char filename1[2*MAXS+10];
	char filename2[2*MAXS+10];
	strcpy(filename1, nome);
	strcat(filename1, "-");
	strcat(filename1, cognome);
	strcpy(filename2, filename1);
	strcat(filename1, ".peso");
	strcat(filename2, ".pressione");
	f1.open(filename1, ios::out);
	f2.open(filename2, ios::out);
	for(int i=0; i<pa->numPaz; i++)
		if(strcmp(pa->paz[i].nome, nome) == 0 &&
		   strcmp(pa->paz[i].cognome, cognome) == 0) {
			for(int j=0; j<pa->paz[i].numVis; j++) {
				f1 << pa->paz[i].vis[j].peso << endl;
				f2 << pa->paz[i].vis[j].pressMin << ' ';
				f2 << pa->paz[i].vis[j].pressMax << endl;
			}	
			return true;
		}
	return false;
}
